Subject: Re: [PATCH 0/3] switch to tombstone-free khashl table

From: Eric Wong <[email-masked]>
Date: Fri, 19 Apr 2024 21:46:44 +0000

Junio C Hamano <[email-masked]> wrote:
> Junio C Hamano <[email-masked]> writes:
> > Eric Wong <[email-masked]> writes:
> >
> >> The memory improvement is minor, but any memory reduction at all
> >> is welcome at this point.  Fortunately, this set of changes is
> >> unintrusive.
> >>
> >> I have some other ideas that I'll hopefully get to implement before
> >> swapping kills all my SSDs (see bottom).
> >
> > Please describe what this topic aims at to sell the topic better.
> > Are we trying to reduce memory footprint?  In other words, if this
> > topic were to hit a released version of Git, what would the short
> > paragraph description for the topic in the release notes look like?
> > ...
> 
> So, did anything happened since this exchange?  I remember that we
> caught and fixed a few minor sparse errors, but other than that, I
> am not sure what to do with this topic.

Not really...  I've been thinking we can beat khashl for our
purposes usage by allowing explicit tombstones to be configured
and getting rid of the ->used bitmap entirely.

One goal is to eventually reuse the code with the open-coded
hash table in object.c   That said, I've been bogged down by
personal crap this year and don't know how/if I'll be able to
hack on it this year.

> Not that I want to merge loud tree-wide topics down during the
> prerelease period...

No worries, we can keep it out for now and work on it
incrementally or drop it entirely in favor of something else
down the line...

git's about to turn 20, and I really want to ensure it and the
tools around it continue to be usable on computers from 20-25
years ago.